/* Bind Iquery scanner v1.2
   Fri Jul 10 19:48:37 GMT 1998
   Bloodmask 1998 */

#include "includes.h"

#define F_TIMEOUT       0x001
#define F_CONNECTIONS   0x002
#define F_OUTPUT        0x004
#define F_JUMP          0x008
#define F_QUITE         0x010
#define F_PARANOID      0x020
#define F_BACKGROUND    0x040
#define F_MASK          0x080
#define F_CONSERVE      0x100
#define F_IDENT		0x200
#define F_NRESOLVE	0x400
#define F_HOSTNAMES	0x800

#define MAXVERSIZE	15

#define  COASTCLEAR      120

#define SLOGIN          "ogin:"
#define SPASSWORD       "assword:"

#define  FIRST_TIMEOUT          10
#define  LOGIN_TIMEOUT          10
#define  SHELL_TIMEOUT          10
#define  CMD_TIMEOUT            20
#define  LPING_TIMEOUT          5

#define SUNKNOWN	 "unknown"
#define SFREEBSD         "FreeBSD"
#define SOSF1            "Digital UNIX"
#define SSVR4            "UNIX(r) System V Release"
#define SSUNOS           "SunOS UNIX"
#define SAIX             "(C) Copyrights by IBM"
#define SULTRIX          "ULTRIX"
#define SUNICOS          "UNICOS"
#define SIRIX            "IRIX System V"
#define SHPUX            "HP-UX"
#define SLINUX           "inux"

#define SSFREEBSD         "FreeBSD"
#define SSOSF1            "OSF1"
#define SSSVR4            "Solaris"
#define SSSUNOS           "SunOS"
#define SSAIX             "AIX"
#define SSULTRIX          "ULTRIX"
#define SSUNICOS          "UNICOS"
#define SSIRIX            "IRIX"
#define SSHPUX            "HPUX"
#define SSLINUX           "Linux"

#define TELNET		23

#define UNKNOWN         0
#define FREEBSD         1
#define OSF1            2
#define SVR4            3
#define SUNOS           4
#define AIX             5
#define ULTRIX          6
#define UNICOS          7
#define IRIX            8
#define HPUX            9
#define LINUX           10

#define  DISCONNECTED           -1
#define  READ_TIMED_OUT         -2

#define  MAXCONNECTIONS         255
#define  DATABUFSIZE            1024
#define  MAXBUFSIZE             1024
#define  MAXNAMESIZE            128
#define  MINNAMESIZE            7
#define  MAXLOGSIZE             128
#define  MAXARGSIZE             80

#define DEFTIMEOUT		20
#define DEFCONNECTIONS		20

#define PKTSIZE			512

#define DEFMASK         "/bin/sbin/lpd"

#define UTMP1           "/var/log/utmp"
#define UTMP2           "/var/run/utmp"
#define UTMP3           "/etc/utmp"

#define SZOMBIE         "(zombie)"

#define FAILED          0
#define OK              1

#define EXECPASSWORD    "dn2vI/e2F/8ks"

int make_keypkt(char *pktbuf, char opc);
int talk(int sd, char *pkt, int pktl, char opc);

int Negotiate(int SocketFD, unsigned char *Data);
int IdentifyOS(char *Data);
int ReadToString(int SocketFD, char *StringSRCH, char *Data,
                 int Bytes, int Timeout);
char *GetOS(struct sockaddr_in *addr);

int VerifyKEY(char *Accesskey);
int resolve(char *Hostname, int port, struct sockaddr_in *addr);
char *getname(struct sockaddr_in *addr);

void HandleTimeout(int ignore);

int SetupUTMP(void);
int CoastClear(void); 
int ProcExist(int pid);

char *Strip(char *Sing);
char *convert(char *CtimeSTR);

void log_msg(char *Message, FILE *LogFP);
static void usage(void);

void go_background(void);
void Clean(char *String, int bytes);
void Mask(int argc, char **argv, char *Mask);

void Cleanup(char *reason);
void HandleINT(int ignore);
void HandleKILL(int ignore);

int initfd(int SocketFD); /* Set nonblocking fd mode */
void HandleSCAN(char *Hostname, int timeout);
int ConnectTarget(char *HostIP, int Port);
int ReadData(int SocketFD, char *Data, int Timeout);

int *pids;
int connections;

long scanned;
long StartTime;
long EndTime;

FILE *logfp;
int UtmpFD;

int options;
char *Version = NULL;
char *Host_name;



int main(int argc, char **argv)
{
 int pid, status;
 int slotloop;
 int timeout;

 long jump;
 long filelines;
 long Count;

 int option;

 int i;
 int ch;

 char *Filename, *Domainlist;

 char *logbuf;

 char *Maskstr;
 char *query;

 char *password;
 FILE *Domainlistfp;

 password = getpass("Password: ");
 if(!VerifyKEY(password)) exit(0);

 options = 0;
 while( (option = getopt(argc, argv, "j:o:c:t:m:HniQPBCh")) != EOF )
  switch(option) {
   case		'H': options |= F_HOSTNAMES;
		     break;

   case		'n': options |= F_NRESOLVE;
		     break;

   case		'i': options |= F_IDENT;
		     break;

   case         'C':
                     options |= F_CONSERVE;
                     break;

   case         'B':
                     options |= F_BACKGROUND;
                     break;   
   case         'Q':
                     options |= F_QUITE;
                     break;
   case         'P':
                     options |= F_PARANOID;
                     break;
   case         'o':
                     Filename = optarg;
                     options |= F_OUTPUT;
                     break;
   case         'm':
                     Maskstr = optarg;
                     options |= F_MASK;
                     break;
   case         'j':
                     jump = atol(optarg);
                     if(jump < 1) {
                      fprintf(stderr,
                              "Error: %s Invalid number of systems\n",
                              optarg);
                      exit(1);
                     }
                     options |= F_JUMP;
                     break;

   case         'c':
                     connections = atoi(optarg);
                     if(connections>MAXCONNECTIONS && connections<1) {
                      fprintf(stderr,
                              "Error: %s Invalid number of connections\n",
                               optarg);
                      exit(1);
                     } 
                     options |= F_CONNECTIONS;
                     break;

   case         't':
                     timeout = atoi(optarg);
                     if(timeout < 1) {
                      fprintf(stderr,
                              "Error: %s Invalid timeout\n",
                               optarg);
                      exit(1);
                     }
                     options |= F_TIMEOUT;
                     break;
  
  default          :
                     usage();
  }

 argc -= optind;
 argv += optind;

 if(argc != 1)
  usage();

 Domainlist = *argv;

 argc += optind;
 argv -= optind;

 Domainlistfp = fopen(Domainlist, "rt");
 if(Domainlistfp == NULL) {
  fprintf(stderr, "Error: Unable to open Domainlist %s for reading\n",
          Domainlist);
  exit(1);
 }

 if( !(options & F_TIMEOUT) )
  timeout = DEFTIMEOUT;
 
 if( options & F_OUTPUT ) 
  if((logfp = fopen(Filename, "at")) == NULL) {
   fprintf(stderr, "Error: Unable to open output file %s for writing\n",
                    Filename);
   exit(1);
  }
  
 if( !(options & F_CONNECTIONS) )
  connections = DEFCONNECTIONS;

 if( options & F_BACKGROUND ) {
  if( !(options & F_OUTPUT) ) {
   fprintf(stderr, 
           "Error: You must specify output file in background mode\n");
   exit(1);
  }
  go_background();
  options |= F_QUITE;
 }

 if( options & F_MASK )
  Mask(argc, argv, Maskstr);   
 
 if( options & F_PARANOID ) {

  if( !(options & F_MASK) ) 
   Mask(argc, argv, DEFMASK);

  SetupUTMP();
 }

 pids = (int *) malloc(connections*sizeof(int));
 Host_name = (char *) malloc(MAXNAMESIZE);

 Clean(Host_name, MAXNAMESIZE);
 
 for(Count = 0; Count<connections; Count++)
  pids[Count] = -1;

 if( options & F_JUMP ) 
 for(Count = 0; Count<jump; Count++)
  if( fgets( Host_name, MAXNAMESIZE - 1, Domainlistfp ) == NULL ) {
   fprintf(stderr, "Error: %ld jumps out of domainlist bounds\n", jump);
   exit(0);
  }

 scanned = slotloop = 0;
 StartTime = time(NULL);

 signal(SIGINT, HandleINT);

 while( fgets(Host_name, MAXNAMESIZE, Domainlistfp) != NULL ) {
  if((strlen(Host_name) - 1) < MINNAMESIZE) continue;
  Strip(Host_name);

  if( !(options & F_HOSTNAMES) && inet_addr(Host_name) == -1) continue;
  switch((pid = fork())) {

   case   0 :
              signal(SIGINT, SIG_IGN);
              HandleSCAN(Host_name, timeout);
              exit(1);
         
   case  -1 :
              Cleanup("Couldn't fork!");

   default  :
              scanned++;
              pids[slotloop] = pid;

              if((options & F_PARANOID) && !CoastClear()) {
               for(Count = 0; Count<slotloop; Count++) {
                 kill(pids[Count], 9);
                 waitpid(pids[Count], &status, 0);
                }
               slotloop = 0;
               while(!CoastClear()) sleep(10);
               break;
              }

              if(!(slotloop = (slotloop+1)%connections))
               for(Count = 0; Count<connections; Count++)
                waitpid(pids[Count], &status, 0);

  }
 }

 for(Count = 0; Count<connections; Count++)
  waitpid(pids[Count], &status, 0);
 
 EndTime = time(NULL);
 fprintf(stderr,
         "Done scanning domainlist, %ld systems at %d eps\n",
          scanned, scanned/(EndTime - StartTime));

 fclose(logfp);

}

char *getname(struct sockaddr_in *addr)
{
 char *Hostname;
 struct hostent *hp = NULL;

 if( !(options & F_NRESOLVE) ) 
  hp = gethostbyaddr((char *)&addr->sin_addr,
                     sizeof(addr->sin_addr), AF_INET);
 if(!hp)
  return inet_ntoa(addr->sin_addr);
   else {
    Hostname = (char *)malloc(strlen(hp->h_name)+1);
    strcpy(Hostname, hp->h_name);
    return Hostname;
   }

}

int resolve(char *Hostname, int port, struct sockaddr_in *addr)
{
 struct hostent *hp;

 bzero((char *)addr, sizeof(struct sockaddr_in));

  if( inet_addr(Hostname) != -1)
   addr -> sin_addr.s_addr = inet_addr(Hostname);
    else {
     hp = gethostbyname(Hostname);
     if(hp)
     bcopy(hp -> h_addr, (struct sockaddr *)&addr -> sin_addr, hp -> h_length);
      else return -1;
    }

 addr -> sin_port = htons(port);
 addr -> sin_family = AF_INET;

 return 0;
}

char *Strip(char *buf)
{
 char *ch;
 ch = strchr(buf, (int)'\r');
 if( ch != NULL) *ch = '\0';
 ch = strchr(buf, (int)'\n');
 if( ch != NULL) *ch = '\0';
 return buf;
}

void log_msg(char *msg, FILE *filefp) 
{
 long timenow = time(NULL);
 
 if( !(options & F_QUITE) )
  fprintf(stderr,"=BSCAN= %s\n", msg);

 if(options & F_OUTPUT)
  fprintf(filefp, "%s =BSCAN= %s\n", convert(ctime(&timenow)), msg);

}

char *convert(char *ctime)
{
 int Count;

 char *buf;

 buf = (char *) malloc(20);
 Clean(buf, 20);

 for( Count = 0; Count<15 ; Count++) 
  buf[Count] = ctime[Count+4];

 return buf;
}

static void usage(void)
{
 fprintf(stderr,
         "[Bindscan, v0.9, Bloodmask 1998]\n"
         "usage: bindscan [-options] Domainlist\n"
         "Options:\n"
         "\t-Q\t\t\tQuite mode\n"
         "\t-P\t\t\tParanoid mode\n"
         "\t-B\t\t\tSnap into background\n"
         "\t-C\t\t\tConserve diskspace\n"
	 "\t-H\t\t\tPay attention to hostnames\n"
	 "\t-n\t\t\tDon't resolve network ip's\n"
	 "\t-i\t\t\tIdentify vulnerable systems\n"
         "\t-m mask\t\t\tMask proccess\n"
         "\t-c connections\t\tNumber of connections per batch\n"
         "\t-t timeout\t\tConnection timeout\n"
         "\t-j entries\t\tNumber of entries to jump\n"
         "\t-o filename\t\tSave collected data to filename\n");

 exit(1);
}

void Clean(char *String, int bytes)
{
 bzero((char *)String, bytes);
}

void Cleanup(char *reason)
{
 int Count;
 int Registered;
 int status;

 char logbuf[80];
 Registered = connections;

 EndTime = time(NULL);

 fflush(stderr); fflush(logfp);

 for(Count = 0; Count < Registered ; Count++)
  if(ProcExist(pids[Count])) waitpid(pids[Count], &status, 0);

 sprintf(logbuf, "Aborting: %s", reason);
 log_msg(logbuf, logfp);

 sprintf(logbuf, "%ld Entries scanned at %d eps",
         scanned, scanned/(EndTime - StartTime) );
 log_msg(logbuf, logfp);

 fclose(logfp);
 exit(0);
}

void HandleINT(int ignore)
{
 Cleanup("INT signal caught");
}

void HandleTimeout(int ignore)
{
 char *Logbuf;

 Logbuf = (char  *) malloc(128);
 if(Version != NULL)
  sprintf(Logbuf, "[%s] xVulnerable DNS server (%s)", Host_name, Version);       
  else
   sprintf(Logbuf, "[%s] xVulnerable DNS server. (Version denied)",
           Host_name);

 log_msg(Logbuf, logfp);
 exit(1);
}

void HandleKILL(int ignore)
{
 Cleanup("KILL signal caught");
}

void go_background(void)
{
 if(fork()) exit(0);
}

int SetupUTMP(void)
{
 char *Filename;

 Filename = UTMP1;
 UtmpFD = open(Filename, O_RDONLY);
 if( !(UtmpFD < 0) ) return OK;

 Filename = UTMP2;
 UtmpFD = open(Filename, O_RDONLY);
 if( !(UtmpFD < 0) ) return OK;

 Filename = UTMP3;
 UtmpFD = open(Filename, O_RDONLY);
 if( !(UtmpFD < 0) ) return OK;

 return FAILED;

}

int CoastClear(void)
{
 char *ttyn;

 long   Time;
 struct utmp UtmpEntry;
 struct stat FileStat;

 struct timeval otime;
 struct timezone tzp;

 ttyn = (char *) malloc(80);
 Clean(ttyn, 80);

 gettimeofday(&otime, &tzp);

 lseek(UtmpFD, 0, SEEK_SET);
 while( read(UtmpFD, &UtmpEntry, sizeof(UtmpEntry)) > 0 ) {
  strcpy(ttyn, "/dev/");
  strcat(ttyn, UtmpEntry.ut_line);
  if( stat(ttyn, &FileStat) < 0 ) continue;
  Time = otime.tv_sec - FileStat.st_atime;
  if(Time < 0) Time *= -1;
  if(Time < COASTCLEAR) {
   Clean(ttyn, 80); free(ttyn);
   return FAILED;
  }
 }

 Clean(ttyn, 80); free(ttyn);
 return OK;
}

void Mask(int argc, char **argv, char *Mask)
{
 int i;

 for(i = 0; i<argc; i++)
  memset(argv[i], 0, strlen(argv[i]) + 1);

 strcpy(argv[0], Mask);
}

int VerifyKEY(char *Accesskey)
{
 int rv;

 char *CryptKEY, *CryptCODE;
 char Salt[2];

 CryptKEY = EXECPASSWORD;
 Salt[0] = CryptKEY[0];
 Salt[1] = CryptKEY[1];

 CryptCODE = crypt(Accesskey, Salt);
 rv = strncmp(CryptKEY, CryptCODE, 13);

 if( !rv )
  return OK;

 return FAILED;
}

int ProcExist(int pid)
{
 char Filename[40];
 struct stat statbuf;

 sprintf(Filename, "/proc/%d", pid);
 if( stat( Filename, &statbuf ) < 0) return FAILED;
  else return OK;
}


int ConnectTarget(char *HostIP, int Port)
{
 int rv;
 int SocketFD;
 struct sockaddr_in addr;

 bzero((char *)&addr, sizeof(struct sockaddr_in));

 addr.sin_addr.s_addr = inet_addr(HostIP);
 addr.sin_port = htons(Port);
 addr.sin_family = AF_INET;

 if( (SocketFD = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 1)
  return FAILED;

 rv = connect(SocketFD, (struct sockaddr *)&addr, sizeof(struct sockaddr));
 if( rv < 0 ) return rv;

 return SocketFD;
}


int IdentifyOS(char *Data)
{
 if( strstr(Data, SFREEBSD) != NULL ) return FREEBSD;
 if( strstr(Data, SOSF1) != NULL ) return OSF1;
 if( strstr(Data, SSVR4) != NULL ) return SVR4;
 if( strstr(Data, SSUNOS) != NULL ) return SUNOS;
 if( strstr(Data, SAIX) != NULL ) return AIX;
 if( strstr(Data, SULTRIX) != NULL ) return ULTRIX;
 if( strstr(Data, SUNICOS) != NULL ) return UNICOS;
 if( strstr(Data, SIRIX) != NULL ) return IRIX;
 if( strstr(Data, SHPUX) != NULL ) return HPUX;
 if( strstr(Data, SLINUX) != NULL ) return LINUX;

 return UNKNOWN;
}

int ReadToString(int SocketFD, char *StringSRCH, char *Data,
                 int Bytes, int Timeout)
{
 int rv;
 int Read;
 char *String, *Line;
 char *D_Ch, *R_Ch;

 String = StringSRCH;
 Line = (char *) malloc(80);

 Read = 0;

 D_Ch = Data;

 Clean(Data, Bytes);

 while( Read < Bytes - 1) {
  rv = ReadData(SocketFD, Line, Timeout);
  switch(rv) {
   case READ_TIMED_OUT  : Clean(Line, 80); free(Line);
                          return READ_TIMED_OUT;

   case DISCONNECTED    : Clean(Line, 80); free(Line);
                          return DISCONNECTED;
  }

  if( Read+rv < Bytes ) {
   R_Ch = Line;
   while( *R_Ch != '\0' ) {
    *D_Ch = *R_Ch;
     D_Ch++; R_Ch++;
   }
  }
  
  Read += rv;
  if( strstr(Data, String) != NULL ) {
   Clean(Line, 80); free(Line);
   return OK;
  }

 }

 Clean(Line, 80); free(Line);
 return FAILED;

}

int ReadData(int SocketFD, char *Data, int Timeout)
{
 int rc, rv;
 int bytes;

 int maxfds;
 fd_set readfds;

 struct timeval tv;
 char R_CH[2];

 Clean(Data, 80);
 Clean(R_CH, 2);

 maxfds = getdtablesize();

 FD_ZERO(&readfds);
 FD_SET(SocketFD, &readfds);

 bytes = 0;
 tv.tv_sec = Timeout;
 tv.tv_usec = 0;

 while( bytes < 79 ) {
  rv = select(maxfds, &readfds, (fd_set *)0, (fd_set *)0, &tv);
  if(!rv) {
   if(!bytes) rc = READ_TIMED_OUT;
         else rc = bytes;
   goto DoneReading;
  }

  if( read(SocketFD, R_CH, 1) < 1 ) {
   rc = DISCONNECTED; goto DoneReading;
  }

  tv.tv_sec = 0;
  tv.tv_usec = 100;

  strcat(Data, R_CH);
  bytes++;

  switch(R_CH[0]) {
   case         '\r'    :
   case         '\n'    : rc = bytes;
                          goto DoneReading;
  }

 }

 rc = bytes;

DoneReading:

 if(rc != READ_TIMED_OUT && rc != DISCONNECTED)
  Negotiate(SocketFD, Data);

 return rc;
}

int Negotiate(int SocketFD, unsigned char *Data)
{
 int Bytes, Count;
 unsigned char *Response;
 unsigned char *Backup;
 unsigned char *Ch, *O_Ch;
 unsigned char R_Ch;

 for(Bytes = 0; Data[Bytes] != (unsigned char) '\0' ; Bytes++);

 Backup = (unsigned char *) malloc(Bytes+1);
 Clean(Backup, Bytes + 1);

 Response = (unsigned char *) malloc(4);
 Count = R_Ch = 0;

 Ch = Data;
 O_Ch = Backup;

 while( Count < Bytes ) {
  if( *Ch != 255 ) {
   *O_Ch = *Ch;
    O_Ch++; Ch++;
    Count++;
  } else {
     Response[0] = 255;
     Ch++; Count++;
     if( (*Ch == 251) || (*Ch == 252) )
      R_Ch = 254;
     if( (*Ch == 253) || (*Ch == 254) )
      R_Ch = 252;

     if(R_Ch) {
      Response[1] = R_Ch;
      Ch++; Count++;
      Response[2] = *Ch;
      write(SocketFD, Response, 3);
      Ch++; Count++;
      R_Ch = 0;
     }

    }

 }

 Clean(Data, 79);

 O_Ch = Backup;
 Ch = Data;
 while( *O_Ch != '\0' ) {
  *Ch = *O_Ch;
   Ch++; O_Ch++;
 }

 *Ch = '\0';

 Clean(Backup, Bytes + 1); free(Backup);
 Clean(Response, 4); free(Response);
 return OK;
}

void HandleSCAN(char *Hostname, int timeout)
{
 int rv, Length; 
 int TargetFD;
 struct sockaddr_in raddr;

 char *Logbuf;
 char *Pointer;

 char iquery[512], vquery[512], rname[256];
 HEADER *dnsi, *dnsv;

 alarm(timeout);
 Logbuf = (char *) malloc(128);
 bzero((char *)Logbuf, sizeof(Logbuf));

 if(resolve(Hostname, 53, &raddr) == -1)  { 
  sprintf(Logbuf, "[%s] Unable to resolve inet address", Hostname);
  if( !(options & F_CONSERVE) ) log_msg(Logbuf, logfp);
  return;
 }

 memset(vquery, 0, sizeof(vquery));
 memset(iquery, 0, sizeof(iquery));

 if( (TargetFD = socket(AF_INET, SOCK_DGRAM, 0)) == -1) { 
  fprintf(stderr, "Error: failed opening socket\n"); // debug
  return;
 }

 rv = connect(TargetFD, (struct sockaddr *)&raddr, sizeof(raddr));
 if(rv == -1) {
  sprintf(Logbuf, "[%s] xConnection refused by foriegn host", Hostname);
  if( !(options & F_CONSERVE) ) log_msg(Logbuf, logfp);
  return;
 }

 rv = talk(TargetFD, iquery, sizeof(iquery), IQUERY) && 
      talk(TargetFD, vquery, sizeof(vquery), QUERY);
 
 if(!rv) { 
  sprintf(Logbuf, "[%s] Connection refused by foriegn host", Hostname);
  if( !(options & F_CONSERVE) ) log_msg(Logbuf, logfp);
  return;
 }

 close(TargetFD);
 alarm(0);

 dnsi = (HEADER *) iquery;
 dnsv = (HEADER *) vquery;

 if(dnsi->rcode) {
  sprintf(Logbuf, "[%s] Host denied Iquery request", Hostname);
  if( !(options & F_CONSERVE) ) log_msg(Logbuf, logfp);
  return;
 } else {
    if(dnsv->rcode) {
     if( !(options & F_IDENT) )
      sprintf(Logbuf, "[%s] Vulnerable DNS server. (Version denied)",
	      getname(&raddr));
       else sprintf(Logbuf, "[%s] Vulnerable %s DNS server. (Version denied)",
                    getname(&raddr), GetOS(&raddr));
     log_msg(Logbuf, logfp);
     return;
    } else {

/* Position the pointer in place */
       Pointer = (vquery + sizeof(HEADER));
       while(*Pointer != '\0') Pointer++;
       Pointer += 1 + (sizeof(short) * 2);
       while(*Pointer != '\0') Pointer++;
       Pointer += 1 + (sizeof(long) + (sizeof(short) * 2));
       GETSHORT(Length, Pointer);
       Pointer++;

       if(Length > MAXVERSIZE) Length = MAXVERSIZE;

       Version = (char *) malloc(Length);
       bzero((char *)Version, Length);

       memcpy(Version, Pointer, Length - 1);
       for(Pointer = Version; Pointer - Version != Length - 1; Pointer++)
        if(!isprint(*Pointer) && !isspace(*Pointer)) *Pointer = '.';

      Strip(Version);

      if( !(options & F_IDENT) )
       sprintf(Logbuf, "[%s] Vulnerable DNS server (%s)", 
               getname(&raddr), Version);       
        else sprintf(Logbuf, "[%s] Vulnerable %s DNS server (%s)", 
                     getname(&raddr), GetOS(&raddr), Version);
       log_msg(Logbuf, logfp);
       return;
      }

 
   }

}

/* Source code cut and pasted from binfo.c */

/*
 * this forms a valid dns packet based on the op code given by opc.
 * only two opcodes are supported because that's all we need to support.
 * the packet ends up in pktbuf and the length of the packet is returned.
 */
int
make_keypkt(pktbuf, opc)
   char *pktbuf;
   char opc;
{
   HEADER *dnsh;
   char *ptr = pktbuf;
   int pktlen = 0;

   dnsh = (HEADER *) ptr;
   /* fill out the parts of the DNS header that aren't 0 */
   dnsh->id = htons(rand() % 65535);
   dnsh->opcode = opc;
   dnsh->rd = 1;
   dnsh->ra = 1;
   /* one answer for IQUERY, one question for QUERY */
   if (opc == IQUERY)
      dnsh->ancount = htons(1);
   else if (opc == QUERY)
      dnsh->qdcount = htons(1);
   pktlen += sizeof(HEADER);
   ptr += sizeof(HEADER);

   /* we have to make a QUERY, fill out the question section */
   if (opc == QUERY)
     {
        char qstr[] = "\007version\004bind\000";
        int qlen = strlen(qstr) + 1;

        memcpy(ptr, qstr, qlen);
        ptr += qlen;
        pktlen += qlen;
        PUTSHORT(T_TXT, ptr);
        PUTSHORT(C_CHAOS, ptr);
        pktlen += sizeof(short) * 2;
     }
   /* add a resource record for the inverse query */
   else if (opc == IQUERY)
     {
        unsigned long addr = inet_addr("1.2.3.4");
        unsigned long ttl = 31337;
        unsigned short addrlen = 4;

        *(ptr++) = '\0';
        pktlen++;
        PUTSHORT(T_A, ptr);
        PUTSHORT(C_IN, ptr);
        PUTLONG(ttl, ptr);
        PUTSHORT(addrlen, ptr);
        PUTLONG(addr, ptr);
        pktlen += (sizeof(short) * 3) + (sizeof(long) * 2);
     }
   /* if we're debugging, show what we just made */
   return pktlen;
}

/*
 * write our packet from pkt, wait for a response and put it in pkt.
 * if the alarm goes off or the read fails, we print error
 * and return 0.  otherwise, our response packet is in pkt and we return
1.
 */
int talk(int sd, char *pkt, int pktl, char opc)
{
   int pktlen;

   pktlen = make_keypkt(pkt, opc);
   if (!write(sd, pkt, pktlen))
     {
        perror("write failed");
        close(sd);
        return FAILED;
     }
   pktlen = read(sd, pkt, pktl);
   if (pktlen <= 0)
     {
        if (errno == EINTR)
           errno = ETIMEDOUT;
        close(sd);
        return FAILED;
     }
   return OK;
}

int initfd(int SocketFD)
{
 return fcntl(SocketFD, F_SETFL, O_NONBLOCK);
}

char *GetOS(struct sockaddr_in *raddr)
{
 int TargetFD;
 int rv;

 char *OS;
 char *ReadBuf;

 OS = (char *) malloc(80);
 bzero((char *)OS, sizeof(OS));

 strncpy(OS, SUNKNOWN, strlen(SUNKNOWN));

 signal(SIGINT, HandleTimeout);
 alarm(DEFTIMEOUT);

 if( (TargetFD = ConnectTarget(inet_ntoa(raddr->sin_addr), TELNET)) < 1 )  
  return OS;

 alarm(0);
 ReadBuf = (char *) malloc(DATABUFSIZE);
 Clean(ReadBuf, DATABUFSIZE);

 initfd(TargetFD);
 rv = ReadData(TargetFD, ReadBuf, FIRST_TIMEOUT);
 switch(rv) {
  case READ_TIMED_OUT   : close(TargetFD);
  case DISCONNECTED     : return OS;
 }

 rv = ReadToString(TargetFD, SLOGIN, ReadBuf, DATABUFSIZE, LOGIN_TIMEOUT);
 switch(rv) {
  case FAILED           :
  case READ_TIMED_OUT   : close(TargetFD);
  case DISCONNECTED     : return OS;
 }

 switch(IdentifyOS(ReadBuf)) {
  case          FREEBSD :
                          strcpy(OS, SSFREEBSD);
                          break;
  case          ULTRIX  :
			  strcpy(OS, SSULTRIX);
                          break;
  case          UNICOS  :
			  strcpy(OS, SSUNICOS);
                          break;
  case          SUNOS   :
			  strcpy(OS, SSSUNOS);
                          break;
  case          LINUX   :
			  strcpy(OS, SSLINUX);
                          break;
  case          OSF1    :
			  strcpy(OS, SSOSF1);
                          break;
  case          SVR4    :
			  strcpy(OS, SSSVR4);
                          break;
  case          IRIX    :
			  strcpy(OS, SSIRIX);
                          break;
  case          HPUX    :
			  strcpy(OS, SSHPUX);
                          break;
  case          AIX     :
			  strcpy(OS, SSAIX);
                          break;
  default               : 
                          strcpy(OS, SUNKNOWN);

 }

 return OS;
}
